<?php

namespace Drupal\k8s\Service\K8sClientExtension\Collections;

use Drupal\k8s\Service\K8sClientExtension\Models\K8sServiceAccountModel;
use Maclof\Kubernetes\Collections\Collection;

/**
 * K8s ServiceAccounts collection.
 */
class K8sServiceAccountCollection extends Collection {

  /**
   * The constructor.
   *
   * @param array $items
   *   The items.
   */
  public function __construct(array $items) {
    parent::__construct($this->getServiceAccounts($items));
  }

  /**
   * Get an array of K8s ServiceAccounts.
   *
   * @param array $items
   *   The items.
   *
   * @return array
   *   The array of K8s ServiceAccounts.
   */
  protected function getServiceAccounts(array $items): array {
    foreach ($items ?: [] as &$item) {
      if ($item instanceof K8sServiceAccountModel) {
        continue;
      }

      $item = new K8sServiceAccountModel($item);
    }

    return $items;
  }

}
