<?php

namespace Drupal\k8s\Service\K8sClientExtension\Repositories;

use Drupal\k8s\Service\K8sClientExtension\Collections\K8sClusterRoleBindingCollection;
use Maclof\Kubernetes\Repositories\Repository;

/**
 * K8s cluster role binding repository.
 */
class K8sClusterRoleBindingRepository extends Repository {

  /**
   * The uri.
   *
   * @var string
   */
  protected $uri = 'clusterrolebindings';

  /**
   * {@inheritdoc}
   */
  protected function createCollection($response): K8sClusterRoleBindingCollection {
    return new K8sClusterRoleBindingCollection($response['items']);
  }

  /**
   * {@inheritdoc}
   */
  protected function getApiVersion(): string {
    return 'rbac.authorization.k8s.io/v1';
  }

}
