<?php

namespace Drupal\k8s\Service\K8sClientExtension\Repositories;

use Maclof\Kubernetes\Collections\PersistentVolumeCollection;
use Maclof\Kubernetes\Repositories\Repository;

/**
 * K8s persistent volume repository.
 */
class K8sPersistentVolumeRepository extends Repository {

  /**
   * The uri.
   *
   * @var string
   */
  protected $uri = 'persistentvolumes';

  /**
   * {@inheritdoc}
   */
  protected function createCollection($response) {
    return new PersistentVolumeCollection($response['items']);
  }

  /**
   * {@inheritdoc}
   */
  protected function sendRequest($method, $uri, $query = [], $body = [], $namespace = FALSE, array $requestOptions = []) {
    $namespace = FALSE;
    $apiVersion = $this->getApiVersion();
    if ($apiVersion == 'v1') {
      $apiVersion = NULL;
    }

    return $this->client->sendRequest($method, $uri, $query, $body, $namespace, $apiVersion);
  }

}
