<?php

namespace Drupal\openstack\Service\Ec2;

use Drupal\aws_cloud\Service\Ec2\Ec2OperationsService;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\openstack\Service\OpenStackServiceInterface;

/**
 * Entity update methods for REST API processing.
 */
class OpenStackOperationsService extends Ec2OperationsService {

  /**
   * OpenStackOperationsService constructor.
   *
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   *   An entity type manager instance.
   * @param \Drupal\openstack\Service\OpenStackServiceInterface $openstack_service
   *   Object for interfacing with OpenStack Service.
   */
  public function __construct(EntityTypeManagerInterface $entity_type_manager,
    OpenStackServiceInterface $openstack_service) {

    // The parent constructor takes care of $this->messenger object.
    parent::__construct($entity_type_manager, \Drupal::service('aws_cloud.ec2'));

    // Setup the entity type manager for querying entities.
    $this->entityTypeManager = $entity_type_manager;
    $this->ec2Service = $openstack_service;
  }

}
