<?php

namespace Drupal\vmware\Controller;

use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * {@inheritdoc}
 */
interface ApiControllerInterface {

  /**
   * Update all VMs.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateVmList($cloud_context): RedirectResponse;

  /**
   * Update all VMs.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateAllVmList(): RedirectResponse;

  /**
   * Update all Hosts.
   *
   * @param string $cloud_context
   *   Cloud context string.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateHostList($cloud_context): RedirectResponse;

  /**
   * Update all Hosts.
   *
   * @return \Symfony\Component\HttpFoundation\RedirectResponse
   *   A redirect response object that may be returned by the controller.
   */
  public function updateAllHostList(): RedirectResponse;

}
