Feature: Log in to and log out of the website
  In order to access the administrative interface
  As an user
  I need to be able to log in to and log out of the website

  Scenario: Log in with the "Anonymous user" role
    Given I am not logged in
    When I go to "/clouds"
    Then I should get a 403 HTTP response
    And I should see the heading "Access denied"

  @api
  Scenario Outline: Log in
    Given I am logged in as a user with the <role> role
    When I go to "/clouds"
    Then I should get a <code> HTTP response
    And I should see the heading <heading>

    Examples:
      |  role                | code | heading                   |
      | "Authenticated user" | 403  | "Access denied"           |
      | "Administrator"      | 200  | "Cloud Service Providers" |

  @api
  Scenario: Log in as an "Administrator"
    Given I am logged in as a user with the "Administrator" role
    When I go to "/clouds"
    Then I should see "Instance Pricing"
    And I should see "Location Map"
    And I should see the button "Apply"

  @api
  Scenario Outline: Log out
    Given I am logged in as a user with the <role> role
    And I am on "/clouds"
    When I click "Log out"
    Then I should be on "/"
    And I should see the link "Log in"

    Examples:
      | role                 |
      | "Authenticated user" |
      | "Administrator"      |
